/*
 * OProfile User Interface
 *
 * Copyright (C) 2007 Nokia Corporation. All rights reserved.
 *
 * Author: Robert Bradford <rob@openedhand.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


#ifndef __RESPONSE_H__
#define __RESPONSE_H__

enum
{
  RESPONSE_OP_OK,
  RESPONSE_OP_ERROR,
  RESPONSE_OP_FILE,
  RESPONSE_OP_ARCHIVE,
  RESPONSE_OP_FILESTAT,
  RESPONSE_OP_STATUS = 69, /* for compatability */
};

typedef struct
{
  char opcode;
  uint32_t length;
  char payload[];
} OpuiResponse;

typedef struct
{
  uint64_t mtime;
  uint64_t size;
  uint64_t mode;
} OpuiResponseFileStat;

typedef struct
{
  uint32_t proto_version;
  uint32_t profiling;
  uint32_t configured;
} OpuiResponseStatus;

#define SIZE_OF_RESPONSE(x) sizeof(OpuiResponse) + x->length
#endif /* __RESPONSE_H__ */
